#ifndef __CFitness_HPP__
#define __CFitness_HPP__

/* "Species" - a CoreWars evolver.  Copyright (C) 2003 'Varfar' 
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 1, or (at your option) any later
 * version. 
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details. 
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA. 
 */

#include "ini.hpp"
#include <iostream>

class CFitness { /* manages the scoring that determines the fitness of a warrior based upon it's success in combat */
	public:
		enum RESULT {
			WIN,
			TIE,
			LOSE,
			RESULT_LAST
		};
		enum CAT {
			ATTACK,
			DEFENCE,
			CAT_LAST
		};
		typedef float NUM;
		static const char *MNEMONIC_RESULT(const RESULT res);
		static const char *MNEMONIC_CAT(const CAT cat);
		void zero(NUM &num) const { num = 0.0F; }
		void score(const CAT /*cat*/,const RESULT res,const NUM weighting,NUM &num,int rounds) { /* adjust a score with this result */
		//	if(cat == ATTACK)
				num += ((_data[ATTACK][res] * weighting) * rounds);
		/*	else // DEFENCE
				num -= ((_data[DEFENCE][res] * weighting) * rounds); //*/
		}
		void read_ini(INIFile &ini); /* loads fitness values; values are REQUIRED */
		CFitness *read_override_ini(INIFile &ini); /* loads fitness values; if any fitness values are
			specified, then a copy of this fitness will be made; all unspecified values in the new
			class will be "inherited" from this one, and any specified values will be overriden.  If nothing
			is specified, then this will be returned */
		void write_ini(std::ostream &os);
		void write_override_ini(std::ostream &os,const CFitness *parent);
	protected:
		NUM _data[CAT_LAST][RESULT_LAST];
};

#endif // __CFitness_HPP__
