#ifndef __CLength_HPP__
#define __CLength_HPP__

/* "Species" - a CoreWars evolver.  Copyright (C) 2003 'Varfar' 
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 1, or (at your option) any later
 * version. 
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details. 
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA. 
 */

#include "ini.hpp"
#include <iostream>

class CLength { /* manages the lengths of a warrior that is allowed */
	public:
		void read_ini(INIFile &ini); /* loads length values; values are REQUIRED */
		CLength *read_override_ini(INIFile &ini); /* loads length values; if any length values are
			specified, then a copy of this length will be made; all unspecified values in the new
			class will be "inherited" from this one, and any specified values will be overriden.  If nothing
			is specified, then this will be returned */
		void write_ini(std::ostream &os);
		void write_override_ini(std::ostream &os,const CLength *parent);
		int min() const { return _min; }
		int max() const { return _max; }
		bool ok(const int size) const { return ((min() <= size) && (size <= max())); }
		int rnd() const; // returns a random length that is ok()
	protected:
		int _min, _max;
};

#endif // __CLength_HPP__
