
/* "Species" - a CoreWars evolver.  Copyright (C) 2003 'Varfar' 
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 1, or (at your option) any later
 * version. 
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details. 
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA. 
 */

#include "species.hpp"

#ifndef _WIN32
	#include <sys/time.h>
	#include <sys/resource.h>
#endif

#include <iostream>

using namespace std;

/***** main program entry point ********************/

int main(int /*argc*/,char /***args*/) {
	CKingdom kingdom;
	
	#ifndef _WIN32
	setpriority(PRIO_PROCESS,0,20); // very low background task priority
	#endif
	
	try {
		cout << "Species " << VERSION << ": a corewars evolver program (c) Will Varfar, 2003" << endl;

/*		// distribution check
		ini.seek("kingdom");
		CDistribution operands("operands",0,8000);
		operands.read_ini(ini);
		for(int i=0; i<100; i++)
			cout << operands.rnd() << ',';
		cout << endl;
	 	return 0;*/
		
		kingdom.load();
		for(;;) { // forever
			kingdom.fight();
		}
	} catch(CSpeciesError *se) {
		cerr << se->desc() << endl;
		delete se;
		return 1;
	} catch(KeyValuePair::KVP_ERROR err) {
		cerr << "INI_PARSER_ERROR " << KeyValuePair::ERROR_MSG(err) << endl;
		return 4;
	} catch(...) {
		cerr << "an unspecified error occurred" << endl;
		return 2;
	}
	return 0;
}
