#ifndef __OPCODE_BRANCH_LOOKUP_HPP__
#define __OPCODE_BRANCH_LOOKUP_HPP__

/* "Species" - a CoreWars evolver.  Copyright (C) 2003 'Varfar' 
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 1, or (at your option) any later
 * version. 
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details. 
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA. 
 */
 
/* this file publishes a lookup for code that is interested in whether something is a branch or not
 * a BRANCH is an instruction that (may) jump to it's A field
 * a SKIP is an instruction that (may) skip the next instruction
 * a CONTINUES is an instruction that (may) continue to the next instruction; only JMP and DAT aren't, infact
 */

#include "insn.h"

extern const bool
	OPCODE_IS_BRANCH[OPCODE_LAST],
	OPCODE_IS_SKIP[OPCODE_LAST],
	OPCODE_CONTINUES[OPCODE_LAST],
	OPCODE_IS_BRANCH_OR_SKIP[OPCODE_LAST];
extern const int
	NUM_OPCODE_BRANCHES,
	NUM_OPCODE_SKIPS,
	NUM_OPCODE_CONTINUES;

	
MODIFIER EFFECTIVE_MODIFIER(const OPCODE opcode,const MODIFIER modifier);
unsigned EFFECTIVE_MODIFIERS(const OPCODE opcode);
	
const char *MNEMONIC_OPCODE(const OPCODE opcode);
const char *MNEMONIC_MODIFIER(const MODIFIER modifier);
const char MNEMONIC_ADDRMODE(const ADDRMODE addrmode);

#endif // __OPCODE_BRANCH_LOOKUP_HPP__

