
#ifndef COMPRESS_H
#define COMPRESS_H

/* "Species" - a CoreWars evolver.  Copyright (C) 2003 'Varfar' 
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 1, or (at your option) any later
 * version. 
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details. 
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA. 
 */

#include <stdio.h>
 
#define COMPRESS_BUFFER ((int)12000)
#define COMPRESS_SAFE_BUFFER ((int)((COMPRESS_BUFFER * 1.1) + 13)) 

typedef struct {
	 FILE *f;
    unsigned long len;
    unsigned char buf[COMPRESS_SAFE_BUFFER];
} comp_buf_t;

// metrics
void init_compress_metrics();
unsigned long long get_physical_bytes();
unsigned long long get_logical_bytes();

// block access
void block_compress(comp_buf_t *src);
void block_decompress(comp_buf_t *dest);

// byte-by-byte writer
void flush_compressed(comp_buf_t *src);
void write_compressed(comp_buf_t *src,unsigned char ch);

#endif // ifndef COMPRESS_H
