#include <stdio.h>
#include "insn.h"
#include "exhaust.h"
#include "asm.h"

#include "compress.h"

#define MAX_CYCLES 80000
#define MAX_OPMOD _OP(OPCODE_LAST,MODIFIER_LAST)
#define CORESIZE 8000

int NWarriors;
unsigned char data[MAX_CYCLES];
unsigned checksum = 0;
unsigned long long count[MAX_OPMOD], insns = 0;

typedef struct {
    unsigned long long djnf, movi;
}
opmod_enquiry_t;
opmod_enquiry_t **opmod_enquiry;

void dump_stats(char **WarriorNames) {
    unsigned int i, j,
    op, mod;
    opmod_enquiry_t enquiry, enquiry_sum;
    char
		// html
		*html_preamble = "<html>\n<body>\n<h1>%s</h1>\n",
		*html_table_preamble = "<h2>%s</h2><table border=\"1\">\n",
		*html_start_row = "<tr>",
		*html_name = "<th>%s</th>",
		*html_value = "<td>%i</td>",
		*html_valueu32 = "<td>%u</td>",
		*html_valueu64 = "<td>%llu</td>",
		*html_valueenquirytype = "<td>djn.f:&nbsp;%u<br/>mov.i:&nbsp;%u</td>",
		*html_end_row = "</tr>\n",
		*html_table_postamble = "</table>\n",
		*html_postamble = "</body>\n</html>\n",
		// tab-seperated-value
		*tsv_preamble = "",
		*tsv_table_preamble = "",
		*tsv_start_row = "",
		*tsv_name = "%s\t",
		*tsv_value = "%i\t",
		*tsv_valueu32 = "%u\t",
		*tsv_valueu64 = "%llu\t",
		*tsv_valueenquirytype = "%u/%u\t",
		*tsv_end_row = "\n",
		*tsv_table_postamble = "",
		*tsv_postamble = "",
		// --- actually used ones ---
		*preamble = html_preamble,
		*table_preamble = html_table_preamble,
		*start_row = html_start_row,
		*name = html_name,
		*value = html_value,
		*valueu32 = html_valueu32,
		*valueu64 = html_valueu64,
		*valueenquirytype = html_valueenquirytype,
		*end_row = html_end_row,
		*table_postamble = html_table_postamble,
		*postamble = html_postamble;

    printf(preamble,"RESULTS");

    printf(table_preamble,"Enquiry Matrix");
    printf(start_row);
    printf(name,"");
    for(i=0; i<NWarriors; i++) {
        printf(name,WarriorNames[i]);
    }
    printf(end_row);

    for(i=0; i<NWarriors; i++) {
        printf(start_row);
        printf(name,WarriorNames[i]);
        for(j=0; j<NWarriors; j++) {
            printf(valueenquirytype,opmod_enquiry[i][j].djnf,opmod_enquiry[i][j].movi);
        }
        printf(end_row);
    }

    printf(table_postamble);

    printf(table_preamble,"Opcode Execution Frequency");
    for(op=0; op<OPCODE_LAST; op++) {
        for(mod=0; mod<MODIFIER_LAST; mod++) {
            if(0 < count[_OP(op,mod)]) {
                printf(start_row);
                printf(name,MNEMONIC_OPCODE[op]);
                printf(name,MNEMONIC_MODIFIER[mod]);
                printf(valueu64,count[_OP(op,mod)]);
                printf(end_row);
            }
        }
    }
    printf(table_postamble);

    printf(table_preamble,"Enquiry");
    printf(start_row);
    printf(name,"Warrior");
    printf(name,"djn.f");
    printf(name,"mov.i");
    printf(end_row);
    enquiry_sum.djnf = 0LL;
    enquiry_sum.movi = 0LL;
    for(i=0; i<NWarriors; i++) {
        printf(start_row);
        printf(name,WarriorNames[i]);
        enquiry.djnf = 0LL;
        enquiry.movi = 0LL;
        for(j=0; j<NWarriors; j++) {
            enquiry.djnf += opmod_enquiry[i][j].djnf;
            enquiry.movi += opmod_enquiry[i][j].movi;
        }
        enquiry_sum.djnf += enquiry.djnf;
        enquiry_sum.movi += enquiry.movi;
        printf(valueu64,enquiry.djnf);
        printf(valueu64,enquiry.movi);
        printf(end_row);
    }
    printf(start_row);
    printf(name,"Sum:");
    printf(valueu64,enquiry_sum.djnf);
    printf(valueu64,enquiry_sum.movi);
    printf(end_row);
    printf(table_postamble);

    printf(table_preamble,"Summary");
    printf(start_row);
    printf(name,"# instructions");
    printf(valueu64,insns);
    printf(end_row);
    printf(start_row);
    printf(name,"checksum");
    printf(valueu32,checksum);
    printf(end_row);
    printf(start_row);
    printf(name,"physical bytes");
    printf(valueu64,get_physical_bytes());
    printf(end_row);
    printf(start_row);
    printf(name,"logical bytes");
    printf(valueu64,get_logical_bytes());
    printf(end_row);
    printf(table_postamble);

    printf(postamble);
}

int load_file(char *fname) {
    comp_buf_t block;
    unsigned int i, self, enemy, len, read, fights = 0,
            djnf, movi;
    unsigned char opmod;
    long pos;
    FILE *fex = fopen(fname,"rb");
    if(fex == NULL) {
        printf("%s: x3\n",fname);
        return 3;
    }
	 block.f = fex;
    if(1 != fread(&self,sizeof(self),1,fex)) {
        printf("x6");
        return 6;
    }
    while(1) {
        pos = ftell(fex);
        if(1 != fread(&enemy,sizeof(enemy),1,fex)) {
            if(!feof(fex)) {
                printf("x1");
                return 1;
            } else
                break;
        }
        if(1 != fread(&len,sizeof(len),1,fex)) {
            printf("x5");
            return 5;
        }
        //printf("%i vs %i = %i ops @ %li\n",fights,enemy,len,pos);
        if(len > 80000) {
            printf("x4");
            return 4;
        }
        read = 0;
        do {
			   block_decompress(&block);
            for(i=0; i<block.len; i++)
                data[read++] = block.buf[i];
        } while(read < len);
        if(read != len) {
            printf("read: %u != %u: x11",read,len);
            return 11;
        }
        for(i=0; i<len; i++) {
            if(data[i] >= MAX_OPMOD) {
                printf("%i = %i x7",i,data[i]);
                return 7;
            }
            switch(data[i]) { // interesting warriors we want to keep track of
            case _OP(DJN,mF):
                opmod_enquiry[self][enemy].djnf++;
                break;
            case _OP(MOV,mI):
                opmod_enquiry[self][enemy].movi++;
                break;
            }
            checksum += data[i];
            count[data[i]]++;
            insns++;
        }
        fights++;
    }
    fclose(fex);
    return 0;
}

int main(int argc,char **args) {
    int i, j;

    NWarriors = argc-1;

    memset(count,0,MAX_OPMOD*sizeof(unsigned long long));
    opmod_enquiry = (opmod_enquiry_t**)malloc(NWarriors*sizeof(opmod_enquiry_t*));
    for(i=0; i<NWarriors; i++) {
        opmod_enquiry[i] = (opmod_enquiry_t*)calloc(NWarriors,sizeof(opmod_enquiry_t));
    }

    for(i=1; i<argc; i++) {
        if(0 != load_file(args[i])) {
            return 1;
        }
    }
    dump_stats(args);
    return 0;
}

